package com.futhark.datagen;

import com.futhark.block.FutharkBlocks;
import com.futhark.item.FutharkItems;
import net.fabricmc.fabric.api.datagen.v1.FabricDataOutput;
import net.fabricmc.fabric.api.datagen.v1.provider.FabricRecipeProvider;
import net.minecraft.data.server.recipe.RecipeJsonProvider;
import net.minecraft.data.server.recipe.ShapedRecipeJsonBuilder;
import net.minecraft.data.server.recipe.ShapelessRecipeJsonBuilder;
import net.minecraft.item.Items;
import net.minecraft.recipe.book.RecipeCategory;
import net.minecraft.util.Identifier;

import java.util.function.Consumer;

public class FutharkRecipeProvider extends FabricRecipeProvider {
    public FutharkRecipeProvider(FabricDataOutput output) {
        super(output);
    }

    @Override
    public void generate(Consumer<RecipeJsonProvider> consumer) {
        ShapedRecipeJsonBuilder.create(RecipeCategory.BUILDING_BLOCKS, FutharkBlocks.JAFFA_JAM_BLOCK, 1)
                .pattern("##")
                .pattern("##")
                .input('#', FutharkItems.JAFFA_JAM)
                .criterion(hasItem(FutharkItems.JAFFA_JAM), conditionsFromItem(FutharkItems.JAFFA_JAM))
                .offerTo(consumer, new Identifier(getRecipeName(FutharkBlocks.JAFFA_JAM_BLOCK)));

        ShapedRecipeJsonBuilder.create(RecipeCategory.TOOLS, FutharkItems.RUNIC_CHISEL, 1)
                .pattern("X  ")
                .pattern(" # ")
                .pattern("  L")
                .input('X', Items.IRON_INGOT)
                .input('#', Items.STICK)
                .input('L', Items.LAPIS_LAZULI)
                .criterion(hasItem(Items.LAPIS_LAZULI), conditionsFromItem(Items.LAPIS_LAZULI))
                .offerTo(consumer, new Identifier(getRecipeName(FutharkItems.RUNIC_CHISEL)));

        ShapedRecipeJsonBuilder.create(RecipeCategory.TOOLS, FutharkItems.JAFFA_CAKE, 6)
                .pattern("CMC")
                .pattern("JJJ")
                .pattern("WWW")
                .input('C', Items.COCOA_BEANS)
                .input('J', FutharkItems.JAFFA_JAM)
                .input('M', Items.MILK_BUCKET)
                .input('W', Items.WHEAT)
                .criterion(hasItem(FutharkItems.JAFFA_JAM), conditionsFromItem(FutharkItems.JAFFA_JAM))
                .offerTo(consumer, new Identifier(getRecipeName(FutharkItems.JAFFA_CAKE)));

        ShapelessRecipeJsonBuilder.create(RecipeCategory.FOOD, FutharkItems.JAFFA_JAM, 1)
                .input(Items.GLASS_BOTTLE)
                .input(Items.SWEET_BERRIES)
                .input(Items.SUGAR)
                .criterion(hasItem(Items.SWEET_BERRIES), conditionsFromItem(Items.SWEET_BERRIES))
                .offerTo(consumer, new Identifier("jaffa_jam_bottle"));

        ShapelessRecipeJsonBuilder.create(RecipeCategory.FOOD, FutharkItems.JAFFA_JAM, 4)
                .input(FutharkBlocks.JAFFA_JAM_BLOCK)
                .input(Items.GLASS_BOTTLE)
                .input(Items.GLASS_BOTTLE)
                .input(Items.GLASS_BOTTLE)
                .input(Items.GLASS_BOTTLE)
                .criterion(hasItem(FutharkBlocks.JAFFA_JAM_BLOCK), conditionsFromItem(FutharkBlocks.JAFFA_JAM_BLOCK))
                .offerTo(consumer, new Identifier("jaffa_jam_bottle_from_jaffa_jam_block"));
    }
}
